#!/usr/bin/env python

import codecs

src = open('partial.html')
dst = codecs.open('body.tex', 'w', encoding='utf-8')

forcelineshift = False

for line in src:
    if line.startswith(r'<h2>'):
        i = line.find(r'</a>')
        #i2 = line.rfind(r'</h2>')
        #line = ''.join([r'\chapter{', line[i1 + 4:i2].title(), r'}'])
        line = line[i + 4:]
    if line.endswith('</h2>\n'):
        line = '\\chapter{' + line[:-6].title() + '} \\noindent' # no newline
    if line.startswith(r'<p>'):
        line = line[3:]
    if line.endswith('</p>\n'):
        line = line[:-5] + '\n'
    if line == '<pre>\n':
        line = r'\begin{quotation}'
        forcelineshift = True
    if line == '</pre>\n':
        assert forcelineshift
        forcelineshift = False
        line = r'\end{quotation}'
    if line.startswith('<hr'):
        line = '\\hrule\n'

    line = line.replace(r'&amp;', r'\&')
    line = line.replace(r'&eacute;', u'\xc3\xa9')
    line = line.replace(r'&deg;', r'$^\circ$')
    line = line.replace(r'&egrave;', u'\xe8')
    line = line.replace(r'&auml;', u'\xe4')
    line = line.replace(r'&iuml;', u'\xef')
    line = line.replace(r'&euml;', u'\xeb')
    line = line.replace(r'&ouml;', u'\xf6')
    line = line.replace(r'&aelig;', u'\xe6')
    line = line.replace(r'&AElig;', u'\xc6')
    line = line.replace(r'&ntilde;', r'\~ n')
    line = line.replace(r'&gt;', r'$>$')
    line = line.replace(r'&ccedil;', r'{\c c}')
    line = line.replace('#', '\#')
    line = line.replace('<br>', r'\\')
    line = line.replace('<i>', r'\emph{')
    line = line.replace('</i>', '}')
    
    line = line.replace('...', r'\ldots\linebreak[0]')

    #i = line.find('...')
    #while i != -1:
    #    if line[i+3].isalnum():
    #        line = line[:i] + r'\ldots{}'+line[i+3:]
    #    i = line.find('...', i + 1)
    
    i = line.find("'")
    quotechars = []
    while i != -1:
        if line[i + 1].isspace():
            quote = "'"
        elif i == 0 or line[i - 1].isspace():
            quote = "`"
        else:
            quote = "'"
        quotechars.append(quote)
        i = line.find("'", i + 1)
    if len(quotechars) > 0:
        assert '%s' not in line
        line = line.replace("'", '%s') 
        line = line % tuple(quotechars)


    i = line.find('"')
    while i != -1:
        if line[i + 1].isspace():
            quote = "''"
        elif line[i + 1].isalpha() or i == 0 or line[i - 1].isspace():
            quote = "``"
        else:
            quote = "''"
        line = line.replace('"', quote, 1)
        i = line.find('"', i + 1)


    dst.write(line)
    if forcelineshift:
        dst.write('\n')
